/***************************************************************************
                              attribute.cpp
                             -------------------
    begin                : Sun Aug 26 2001
    copyright            : (C) 2000 by The Genes Development Team
    email                : Geert.Vantienen@advalvas.be
    module               : Genes Datamodel
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include "attribute.h"

// ------------------------------------------------------------------------
Attribute::Attribute(const GenesDataId& aid, AttributeType attributeType, 
		     const String& value)
  : GenesData (aid),
    attributeType_ (attributeType),
    value_(value)
{
}

// ------------------------------------------------------------------------
Attribute::~Attribute()
{
}

// ------------------------------------------------------------------------
Attribute::Attribute (const Attribute& attribute)
  : GenesData (attribute),
    attributeType_ (attribute.attributeType_),
    value_(attribute.value_)
{
  //cout << "Copy constructor Attribute" << endl;
}

// ------------------------------------------------------------------------
Attribute::AttributeType Attribute::getAttributeType() const
{
  return (attributeType_);
}

// ------------------------------------------------------------------------
const String& Attribute::getValue() const
{
  return (value_);
}

// ------------------------------------------------------------------------
bool Attribute::isValid() const
{
  return (getAttributeType() != Attribute::undefined);
}

// ------------------------------------------------------------------------

