/***************************************************************************
                                attribute.h
                             -------------------
    begin                : Sun Aug 26 2001
    copyright            : (C) 2001 by The Genes Development Team
    email                : Geert.Vantienen@advalvas.be
    module               : Genes Datamodel
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#ifndef ATTRIBUTE_H
#define ATTRIBUTE_H

/**
  *@author The Genes Development Team
  */
#include <datamodel/genesData.h>
#include <datamodel/String.h>

class Attribute : public GenesData
{
public:
  typedef enum {undefined, title, education, occupation, religion,
		caste, phy_descr, ident_no, nationality, child_count,
		marriage_count, property, soc_sec
  } AttributeType;

  Attribute(const GenesDataId&, AttributeType, const String& value);
  ~Attribute();
  Attribute (const Attribute&);

  AttributeType getAttributeType() const;
  const String& getValue() const;
  bool          isValid() const;

 private:
  AttributeType attributeType_;
  String        value_;
};

#endif
