/***************************************************************************
                            extraRecordData.h 
                           -------------------
    begin                : Sat Aug 111 2001
    copyright            : (C) 2001 by The Genes Development Team
    email                : Geert.Vantienen@advalvas.be
    module               : Genes Datamodel
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#include "extraRecordData.h"

// ------------------------------------------------------------------------
ExtraRecordData::ExtraRecordData()
  : source_(""),
    note_("")
{
}

// ------------------------------------------------------------------------
ExtraRecordData::ExtraRecordData (const ExtraRecordData& extra)
  : source_(extra.source_),
    note_(extra.note_)
{
  // @TODO change this when source and note are lists !
}

// ------------------------------------------------------------------------
ExtraRecordData::~ExtraRecordData()
{
}

// ------------------------------------------------------------------------
// we should keep a list of sources !!!
void ExtraRecordData::addSource (const SourceCitation& source)
{
  source_ = source;
}

// ------------------------------------------------------------------------
void ExtraRecordData::addNote (const NoteCitation& note)
{
  note_ = note;
}

// ------------------------------------------------------------------------
const SourceCitation& ExtraRecordData::getSource() const
{
  return (source_);
}

// ------------------------------------------------------------------------
const NoteCitation& ExtraRecordData::getNote() const
{
  return (note_);
}

// ------------------------------------------------------------------------
void ExtraRecordData::clearNotes()
{
  note_ = NoteCitation("");
}

// ------------------------------------------------------------------------

