/***************************************************************************
                            extraRecordData.h 
                           -------------------
    begin                : Sat Aug 111 2001
    copyright            : (C) 2001 by The Genes Development Team
    email                : Geert.Vantienen@advalvas.be
    module               : Genes Datamodel
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#ifndef EXTRARECORDDATA_H
#define EXTRARECORDDATA_H

/**
  *@author The Genes Development Team
  */

#include <datamodel/sourceCitation.h>
#include <datamodel/noteCitation.h>

class ExtraRecordData
{
public:
  ExtraRecordData();
  ExtraRecordData (const ExtraRecordData&);
  ~ExtraRecordData();

  void addSource (const SourceCitation&);
  void addNote (const NoteCitation&);
  void clearNotes ();
  // void concatNote (const String&);

  const SourceCitation& getSource() const;
  const NoteCitation&   getNote() const;

 private:
  // source and note should be lists !!!
  NoteCitation   note_;
  SourceCitation source_;
  // surity ?

};

#endif
