/***************************************************************************
                          family.h  -  description
                             -------------------
    begin                : Fri Mar 17 2000
    copyright            : (C) 2000 by The Genes Development Team
    email                : slambo@msn.fullfeed.com
                           Geert.Vantienen@advalvas.be
    module               : Genes Datamodel
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef FAMILY_H
#define FAMILY_H


/**
  *@author The Genes Development Team
  */

#include <datamodel/genesData.h>
#include <datamodel/extraRecordData.h>
#include <datamodel/event.h>
#include <list>

class Family : public GenesData, public ExtraRecordData
{
public: 
    Family(const GenesDataId&);
    ~Family();
    Family(const Family&);

    void               setFather (const GenesDataId&);
    void               setMother (const GenesDataId&);
    void               addChild  (const GenesDataId&);

    const GenesDataId& getFather () const;
    const GenesDataId& getMother () const;
    const list<GenesDataId>&  getChildren () const;

    Event*             getMarriageEvent();
    Event*             getDivorceEvent();
    void               addEvent (Event*);
    const list<Event*>& getEventList () const;
    
private:
    GenesDataId        fatherId_;
    GenesDataId        motherId_;
    list<GenesDataId>  children_;
    Event*             marriage_;
    Event*             divorce_;
    list<Event*>       eventList_;
};

#endif
