#ifndef GENESINFOMODEL_H
#define GENESINFOMODEL_H

/***************************************************************************
                         genesInfomodel.h
                        -------------------
    begin                : 16 Jul 2000
    copyright            : (C) 2000 by The Genes Development Team
    email                : Geert.Vantienen@advalvas.be
    module               : Genes Datamodel
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/
// This class should be used to access all Information ...
// as well by userInterface module as other (import, export, wizard) modules
// need better name for this class ?
// @TODO add family list, source list, event list ,  ....


#include "personInfoList.h"
#include <datamodel/genesDataId.h>
#include <datamodel/subject.h>
class Family;
class Person;
class Event;
class Attribute;
class Source;
class Note;

class GenesInfomodel : public Subject
{
 public:
  GenesInfomodel ();
  ~GenesInfomodel ();

  PersonInfoList& getPersonInfoList ();
  Person*         getPerson (const GenesDataId& pid);
  Family*         getFamily (const GenesDataId& fid);
  Event*          getEvent (const GenesDataId& sid);
  Attribute*      getAttribute (const GenesDataId& sid);
  Source*         getSource (const GenesDataId& sid);
  Note*           getNote (const GenesDataId& sid);
  PersonInfo*     getPersonInfo (const GenesDataId& pid);
  PersonInfo*     getFatherInfoFrom (const GenesDataId& pid);
  PersonInfo*     getMotherInfoFrom (const GenesDataId& pid);

  void            addPerson (Person*);    // need boolean for this ?
  void            addFamily (Family*);    // need boolean for this ?
  void            addEvent (Event*);
  void            addAttribute (Attribute*);
  void            addSource (Source*);
  void            addNote (Note*);
  void            buildInfoList ();
  void            clearList ();

 private:

  PersonInfoList         infolist_;
  list<Person*>          personList_;
  list<Family*>          familyList_;
  list<Event*>           eventList_;
  list<Attribute*>       attributeList_;
  list<Source*>          sourceList_;
  list<Note*>            noteList_;
};

#endif
