/***************************************************************************
                              note.cpp
                          -------------------
    begin                : Tue Aug 15 2001
    copyright            : (C) 2001 by The Genes Development Team
    email                : Geert.Vantienen@advalvas.be
    module               : Genes Datamodel
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include "note.h"

// ------------------------------------------------------------------------
Note::Note(const GenesDataId& id)
  : GenesData (id)
{
}

// ------------------------------------------------------------------------
Note::Note(const Note& src)
  : GenesData (src),
    text_ (src.text_)
{
}

// ------------------------------------------------------------------------
Note::~Note()
{
}

// ------------------------------------------------------------------------
void Note::addText (const String& str)
{
  text_ = text_ + "\n" + str;
}

// ------------------------------------------------------------------------
void Note::concatText (const String& str)
{
  text_ = text_ + str;
}

// ------------------------------------------------------------------------
const String& Note::getText() const
{
  return (text_);
}

// ------------------------------------------------------------------------
