/***************************************************************************
                            noteCitation.cpp
                          -------------------
    begin                : Sun Aug 19 2001
    copyright            : (C) 2001 by The Genes Development Team
    email                : Geert.Vantienen@advalvas.be
    module               : Genes Datamodel
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include "noteCitation.h"

// ------------------------------------------------------------------------
NoteCitation::NoteCitation(const GenesDataId& id)
  : isRecord_ (true),
    nid_ (id),
    text_("")
{
}

// ------------------------------------------------------------------------
NoteCitation::NoteCitation(const String& str)
  : isRecord_ (false),
    nid_ (GenesDataId::noteId),
    text_(str)
{
}

// ------------------------------------------------------------------------
NoteCitation::NoteCitation(const NoteCitation& src)
  : isRecord_ (src.isRecord_),
    nid_ (src.nid_),
    text_(src.text_)
{
}

// ------------------------------------------------------------------------
NoteCitation::~NoteCitation()
{
}

// ------------------------------------------------------------------------
void NoteCitation::addText (const String& str)
{
  text_ = text_ + "\n" + str;
}

// ------------------------------------------------------------------------
const String& NoteCitation::getText() const
{
  return (text_);
}

// ------------------------------------------------------------------------
bool NoteCitation::isNoteRecord () const
{
  return (isRecord_);
}

// ------------------------------------------------------------------------
GenesDataId NoteCitation::getRecordId() const
{
  return (nid_);
}

// ------------------------------------------------------------------------
