/***************************************************************************
                          personInfo.cpp
                        -------------------
    begin                : 16 Jul 2000
    copyright            : (C) 2000 by The Genes Development Team
    email                : Geert.Vantienen@advalvas.be
    module               : Genes Datamodel
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/
// this contains all information that is shown in the persons overview list

#include "personInfo.h"
#include <iostream.h>

// ------------------------------------------------------------------------
PersonInfo::PersonInfo (const GenesDataId& pid, int mark, 
			String surname, String firstname, 
			int birthyear, int deathyear)
  : pid_ (pid),
    mark_ (mark),
    surname_ (surname),
    firstname_ (firstname),
    birthyear_ (birthyear),
    deathyear_ (deathyear),
    row_(0)
{
}

// ------------------------------------------------------------------------
PersonInfo::PersonInfo (const PersonInfo& info)
  : pid_ (info.pid_),
    mark_ (info.mark_),
    surname_ (info.surname_),
    firstname_ (info.firstname_),
    birthyear_ (info.birthyear_),
    deathyear_ (info.deathyear_),
    row_ (info.row_)
{
  // is this really used ?
}

// ------------------------------------------------------------------------
PersonInfo::~PersonInfo ()
{
}

// ------------------------------------------------------------------------
// get the person Id (internal id)
const GenesDataId& PersonInfo::getPid () const
{
  return (pid_);
}

// ------------------------------------------------------------------------
int PersonInfo::getMark () const
{
  return (mark_);
}

// ------------------------------------------------------------------------
// get the Name of the person
String PersonInfo::getSurname () const
{
  return (surname_);
}

// ------------------------------------------------------------------------
// get the Name of the person
String PersonInfo::getFirstname () const
{
  return (firstname_);
}

// ------------------------------------------------------------------------
// get the birthyear of the person
int PersonInfo::getBirthyear () const
{
  return (birthyear_);
}

// ------------------------------------------------------------------------
// get the birthyear of the person
int PersonInfo::getDeathyear () const
{
  return (deathyear_);
}

// ------------------------------------------------------------------------
void PersonInfo::setMark (int mark)
{
  mark_ = mark;
}

// ------------------------------------------------------------------------
void PersonInfo::setRow (int row)
{
  row_ = row;
}

// ------------------------------------------------------------------------
int PersonInfo::getRow () const
{
  return (row_);
}

// ------------------------------------------------------------------------
