#ifndef PERSONINFO_H
#define PERSONINFO_H

/***************************************************************************
                           personInfo.h
                        -------------------
    begin                : 16 Jul 2000
    copyright            : (C) 2000 by The Genes Development Team
    email                : Geert.Vantienen@advalvas.be
    module               : Genes Datamodel
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/
// this contains all information that is shown in the persons overview list

#include <datamodel/String.h>
#include <datamodel/genesDataId.h>

class PersonInfo
{
 public:
  PersonInfo (const GenesDataId& pid, int mark, 
	      String surname, String firstname, 
	      int birthyear, int deathyear);
  ~PersonInfo ();
  PersonInfo (const PersonInfo&);

  const GenesDataId& getPid () const;
  int                getMark () const;
  String             getFirstname () const;
  String             getSurname () const;
  int                getBirthyear  () const;
  int                getDeathyear  () const;

  void               setMark (int mark);
  void               setRow (int row);
  int                getRow () const;

 private:
  GenesDataId        pid_;
  int                mark_;
  String             firstname_;
  String             surname_;
  int                birthyear_;
  int                deathyear_;
  int                row_;
};

#endif
