/***************************************************************************
                         personInfoList.cpp
                        -------------------
    begin                : 16 Jul 2000
    copyright            : (C) 2000 by The Genes Development Team
    email                : Geert.Vantienen@advalvas.be
    module               : Genes Datamodel
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/
#include "personInfoList.h"
#include "personInfo.h"
#include "genesDataId.h"

// ------------------------------------------------------------------------
PersonInfoList::PersonInfoList ()
{
}

// ------------------------------------------------------------------------
PersonInfoList::~PersonInfoList ()
{
}

// ------------------------------------------------------------------------
// @TODO check first if the pid is not yet in the list ...
void PersonInfoList::add (PersonInfo* info)
{
  list_.push_back(info);
}

// ------------------------------------------------------------------------
list<PersonInfo*>& PersonInfoList::getList () // should return const ?
{
  return (list_);
}

// ------------------------------------------------------------------------
PersonInfo* PersonInfoList::getPersonInfo (const GenesDataId& pid)
{
  PersonInfo* found = 0;
  int loop  = 1;

  if ((! pid.isValid()) || (! pid.isPerson()))
    {
      loop = 0;
    }
  list<PersonInfo*>::iterator iter = list_.begin();
  while (loop)
    {
      if (iter == list_.end())
	{
	  loop = 0;
	}
      else
	{
	  PersonInfo* temp = *iter;
	  if (temp != 0)
	    {
	      if (temp->getPid() == pid)
		{
		  found = temp;
		}
	    }
	  iter++;
	}
    }
  return (found);
}

// ------------------------------------------------------------------------
void PersonInfoList::clearList ()
{
  cout << "clearList (PersonInfoList)" << endl;
  list<PersonInfo*>::iterator iter = list_.begin();
  while (iter != list_.end())
    {
      PersonInfo* info = *iter;
      delete info;
      iter++;
    }
  while (! list_.empty())
    {
      list_.pop_front();
    }
}

// ------------------------------------------------------------------------
