/***************************************************************************
                          repository.h  -  description
                             -------------------
    begin                : Mon Feb 28 2000
    copyright            : (C) 2000 by the Genes Development Team
													 Sean Lamb, Project Lead
    email                : slambo@msn.fullfeed.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef REPOSITORY_H
#define REPOSITORY_H


/**
  *@author Sean Lamb
  */

#include <string>

class Repository
{

public:

	// Constructors and destructor...
	Repository();
	Repository(const Repository &);
	~Repository();

private:

	// Data members...
	// NOTE: I'm still debating over whether or not we should keep the repository's
  // hours of operation as separate fields, or leave that information in the notes
  // field for the user to enter as he wishes.
	long		r_id_;		// The repository ID; the key for the database table
	string  r_name_;  // The name, and...      address...
	string	r_addr1_, r_addr2_, r_city_, r_region_, r_postcode_, r_country;
	string	r_phone_; // The general phone number.
	string	r_notes_; // Freeform notes.

};

#endif
