/***************************************************************************
                              source.cpp
                          -------------------
    begin                : Tue Aug 14 2001
    copyright            : (C) 2001 by The Genes Development Team
    email                : Geert.Vantienen@advalvas.be
    module               : Genes Datamodel
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include "source.h"

// ------------------------------------------------------------------------
Source::Source(const GenesDataId& id)
  : GenesData (id)
{
}

// ------------------------------------------------------------------------
Source::Source(const Source& src)
  : GenesData (src),
    title_ (src.title_),
    author_ (src.author_),
    publication_ (src.publication_),
    text_ (src.text_)
{
}

// ------------------------------------------------------------------------
Source::~Source()
{
}

// ------------------------------------------------------------------------
void Source::setTitle (const String& str)
{
  title_ = str;
}

// ------------------------------------------------------------------------
void Source::setAuthor (const String& str)
{
  author_ = str;
}

// ------------------------------------------------------------------------
void Source::setPublication (const String& str)
{
  publication_ = str;
}

// ------------------------------------------------------------------------
void Source::addText (const String& str)
{
  text_ = text_ + "\n" + str;
}

// ------------------------------------------------------------------------
const String& Source::getText() const
{
  return (text_);
}

// ------------------------------------------------------------------------
const String& Source::getTitle() const
{
  return (title_);
}

// ------------------------------------------------------------------------
