/***************************************************************************
                              source.h
                          -------------------
    begin                : Tue Aug 14 2001
    copyright            : (C) 2001 by The Genes Development Team
    email                : Geert.Vantienen@advalvas.be
    module               : Genes Datamodel
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef SOURCE_H
#define SOURCE_H


/**
  *@author The Genes Development Team
  */

#include <datamodel/genesData.h>
#include <datamodel/String.h>

class Source : public GenesData
{
public: 
    Source(const GenesDataId&);
    Source(const Source&);
    ~Source();

    void setTitle (const String&);
    void setAuthor (const String&);
    void setPublication (const String&);
    void addText (const String&);

    const String& getText() const;
    const String& getTitle() const;

private:
  String        title_;
  String        author_;
  String        publication_;
  String        text_;
  // note
  
};

#endif
