/***************************************************************************
                          sourceCitation.cpp
                          -------------------
    begin                : Sun Aug 19 2001
    copyright            : (C) 2001 by The Genes Development Team
    email                : Geert.Vantienen@advalvas.be
    module               : Genes Datamodel
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include "sourceCitation.h"

// ------------------------------------------------------------------------
SourceCitation::SourceCitation(const GenesDataId& id)
  : isRecord_ (true),
    sid_ (id),
    text_("")
{
}

// ------------------------------------------------------------------------
SourceCitation::SourceCitation(const String& str)
  : isRecord_ (false),
    sid_ (GenesDataId::sourceId),
    text_(str)
{
}

// ------------------------------------------------------------------------
SourceCitation::SourceCitation(const SourceCitation& src)
  : isRecord_ (src.isRecord_),
    sid_ (src.sid_),
    text_(src.text_)
{
}

// ------------------------------------------------------------------------
SourceCitation::~SourceCitation()
{
}

// ------------------------------------------------------------------------
void SourceCitation::addText (const String& str)
{
  text_ = text_ + "\n" + str;
}

// ------------------------------------------------------------------------
const String& SourceCitation::getText() const
{
  return (text_);
}

// ------------------------------------------------------------------------
bool SourceCitation::isSourceRecord () const
{
  return (isRecord_);
}

// ------------------------------------------------------------------------
GenesDataId SourceCitation::getRecordId() const
{
  return (sid_);
}

// ------------------------------------------------------------------------
