/***************************************************************************
                           sourceCitation.h
                          -------------------
    begin                : Sun Aug 19 2001
    copyright            : (C) 2001 by The Genes Development Team
    email                : Geert.Vantienen@advalvas.be
    module               : Genes Datamodel
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef SOURCECITATION_H
#define SOURCECITATION_H


/**
  *@author The Genes Development Team
  */

#include <datamodel/genesDataId.h>
#include <datamodel/String.h>

class SourceCitation
{
public: 
    SourceCitation(const GenesDataId&);
    SourceCitation(const String&);
    SourceCitation(const SourceCitation&);
    ~SourceCitation();

    bool isSourceRecord () const;
    void addText (const String&);
    const String& getText() const;
    GenesDataId getRecordId() const;

private:
    bool        isRecord_;
    GenesDataId sid_;
    String      text_;
};

#endif
