/***************************************************************************
                              subject.cpp
                          -------------------
    begin                : Mon Nov 05 2001
    copyright            : (C) 2001 by The Genes Development Team
    email                : Geert.Vantienen@advalvas.be
    module               : Genes Datamodel
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#include "subject.h"
#include "observer.h"

// ------------------------------------------------------------------------
Subject::Subject()
  : isBlocking_ (false)
{
}

// ------------------------------------------------------------------------
Subject::~Subject()
{
}

// ------------------------------------------------------------------------
void Subject::attach (Observer* obs)
{
  cout << "Add new observer" << endl;
  observers_.push_back (obs);
}

// ------------------------------------------------------------------------
void Subject::detach (Observer* obs)
{
  observers_.remove (obs);
}

// ------------------------------------------------------------------------
void Subject::notify ()
{
  if (! isBlocking_)
    {
      cout << "Notifying the observers\n";
      list<Observer*>::iterator iter = observers_.begin();
      for (; iter != observers_.end(); ++iter)
	{
	  Observer* obs = *iter;
	  if (obs != 0)
	    {
	      obs->update (this);
	    }
	}
    }
}

// ------------------------------------------------------------------------
void Subject::block_updates ()
{
  isBlocking_ = true;
}

// ------------------------------------------------------------------------
// will send a notify !
void Subject::deblock_updates ()
{
  isBlocking_ = false;
  notify();
}

// ------------------------------------------------------------------------
