#ifndef IMPORTGEDCOM_H
#define IMPORTGEDCOM_H

/***************************************************************************
                           importGedcom.h
                        -------------------
    begin                : 30 Dec 2001
    copyright            : (C) 2001 by The Genes Development Team
    email                : Geert.Vantienen@advalvas.be
    module               : Genes Test
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/
// this module depends on gedcom-parse library

#include <genesCore/genesImportCore.h>
#include <datamodel/genesDataId.h>
#include <gedcom.h>
#include <map>

class ImportGedcom : public GenesImportCore
{
 public:
  ImportGedcom (GenesApplication&);
  virtual ~ImportGedcom ();

  // @TODO return GenesStatus
  virtual void load(const String&, GenesInfomodel& datamodel,
		    MsgHandler hnd=NULL); 
  GenesDataId translateIdFrom (Gedcom_val parsed_value,
			       GenesDataId::DataIdType);

  static ImportGedcom* myself_;
  static MsgHandler handler_;
  GenesInfomodel* datamodel_;
  
 private:
  map<String, GenesDataId> gedKeys_;
 
};

#endif
