/***************************************************************************
                        genesApplication.cpp
                        -------------------
    begin                : Mon 18 Dec 2000
    copyright            : (C) 2000 by The Genes Development Team
    email                : Geert.Vantienen@advalvas.be
    module               : Genes Core
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#include "genesApplication.h"
#include "genesUICore.h"
#include "genesImportCore.h"
#include "../datamodel/genesInfomodel.h"
#include "config.h"
#include <libintl.h>
#define _(string) gettext (string)
#define N_(string) (string)

// ------------------------------------------------------------------------
GenesApplication::GenesApplication ()
  : datamodel_(0),
    userInterface_ (0),
    nbImportMap_ (0)
{
}

// ------------------------------------------------------------------------
GenesApplication::~GenesApplication ()
{
  // @TODO cleanup ui + maps
}

// ------------------------------------------------------------------------
void GenesApplication::setDatamodel (GenesInfomodel* data)
{
  datamodel_ = data;
}

// ------------------------------------------------------------------------
void GenesApplication::setUserInterface (GenesUICore* ui)
{
  userInterface_ = ui;
}

// ------------------------------------------------------------------------
void GenesApplication::registerImportModule (GenesImportCore* module)
{
  if (nbImportMap_ < 5)
    {
      importMap_[nbImportMap_++] = module;
    }
}

// ------------------------------------------------------------------------
GenesImportCore* GenesApplication::getImportModule (const String& moduleName)
{
  GenesImportCore* module = 0;
  int loop = 1;
  int iter = 0;
  while (loop)
    {
      if (importMap_[iter] != 0)
	{
	  if (moduleName == importMap_[iter]->getName())   // @REMARK ok ?
	    {
	      module = importMap_[iter];
	      loop = 0;
	    }
	}
      
      if (++iter >= nbImportMap_)
	{
	  loop = 0;
	}
    }
  return (module);
}

// ------------------------------------------------------------------------
GenesInfomodel* GenesApplication::getDatamodel ()
{
  return (datamodel_);
}

// ------------------------------------------------------------------------
void GenesApplication::start ()
{
  setlocale (LC_ALL, "");
  bindtextdomain (PACKAGE, LOCALEDIR);
  textdomain (PACKAGE);
  cout << _("Starting up ...") << endl;
}

// ------------------------------------------------------------------------
void GenesApplication::loop ()
{
  if (userInterface_ != 0)
    {
      userInterface_->loop();
    }
}

// ------------------------------------------------------------------------
void GenesApplication::stop ()
{
  cout << "Closing down ..." << endl;
}

// ------------------------------------------------------------------------
