#ifndef GENESAPPLICATION_H
#define GENESAPPLICATION_H

/***************************************************************************
                          genesApplication.h
                         -------------------
    begin                : Mon 18 Dec 2000
    copyright            : (C) 2000 by The Genes Development Team
    email                : Geert.Vantienen@advalvas.be
    module               : Genes Core
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#include <datamodel/String.h>

class GenesInfomodel;
class GenesUICore;
class GenesImportCore;

class GenesApplication
{
 public:
  GenesApplication();
  ~GenesApplication();

  void setDatamodel (GenesInfomodel*);
  void setUserInterface (GenesUICore*);
  void registerImportModule (GenesImportCore*);

  GenesImportCore* getImportModule (const String& moduleName);
  GenesInfomodel*  getDatamodel ();

  void start();
  void loop();
  void stop();

 private:
  GenesInfomodel*  datamodel_;
  GenesUICore*     userInterface_;
  GenesImportCore* importMap_[5];      // @TODO make it a real map/list
  int              nbImportMap_;
};

#endif
