#ifndef GENESIMPORTCORE_H
#define GENESIMPORTCORE_H

//---------------------------------------------------------------
/***************************************************************************
                         GenesImportCore.h
                        -------------------
    begin                : Mon 18 Dec 2000
    copyright            : (C) 2000 by The Genes Development Team
    email                : Geert.Vantienen@advalvas.be
    module               : Genes Core
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         * 
 ***************************************************************************/

#include <datamodel/String.h>
class GenesInfomodel;
class GenesApplication;

typedef void (*MsgHandler)(string msg);

class GenesImportCore
{
 public:
  virtual ~GenesImportCore ();
  const String& getName() const;

  virtual void initObject ();
  // @TODO later return GenesStatus
  virtual void load(const String& from, GenesInfomodel& datamodel,
		    MsgHandler handler=NULL); 

 protected:
  GenesImportCore (GenesApplication&, const String& moduleName);
  // @REMARK maybe not protected for batching
  // @REMARK add copy constructor ???



 private:
  GenesApplication& application_;
  String            moduleName_;
};

#endif
