#ifndef GENESUICORE_H
#define GENESUICORE_H

/***************************************************************************
                          genesUICore.h
                        -------------------
    begin                : 16 Dec 2000
    copyright            : (C) 2000 by The Genes Development Team
    email                : Geert.Vantienen@advalvas.be
    module               : Genes Core
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/
// base class for the User Interface.

#include <datamodel/String.h>

class GenesApplication;
class Person;

class GenesUICore
{
 public:
  GenesUICore (GenesApplication&, const String& moduleName);
  virtual ~GenesUICore ();
  const String&     getName() const;
  GenesApplication& getApplication() const;

  virtual void initObject ();
  virtual void showError (String text);
  virtual void loop();                          // the main loop
  virtual void quit();                          // quit the application
  virtual void showPerson (const Person&);
  virtual void showIndex();

  // virtual void showError (const GenesStatus&);
  // virtual void showStatus (String text);
  // virtual void setBusy (int busy);           // @TODO use boolean
  // virtual void askQuestion (String);         // , Callback); 
  // virtual void createMenus ();
  // virtual void showFamily ();                //const Family&

 private:
  GenesApplication& application_;
  String            moduleName_;
};

#endif
