// generated 2002/1/30 19:15:26 CET by gvtienen@gandalf.(none)
// using glademm V0.5_11f
//
// newer (non customized) versions of this file go to EventWnd.cc_new

// This file is for your program, I won't touch it again!

#include "config.h"
#include "EventWnd.hh"

#include "glade2UI.h"
#include "gladeUtil.h"
#include <datamodel/genesInfomodel.h>
#include <datamodel/event.h>
#include <datamodel/note.h>
#include <datamodel/source.h>
#include <utils/showUtils.h>
#include <stdio.h>

// ------------------------------------------------------------------------
EventWnd::EventWnd (Glade2UI& ui, GenesInfomodel& datamodel, Event& event, 
		    const String& name, bool readonly)
  : ui_(ui),
    readonly_(readonly),
    datamodel_(datamodel),
    event_(event),
    name_(name)
{
  if (readonly_)
    {
      setReadonly();
    }
}

// ------------------------------------------------------------------------
EventWnd::~EventWnd()
{
}

// ------------------------------------------------------------------------
// fill in all fields of the window
void EventWnd::initObject()
{
  GladeUtil::setText (dateTf,  ShowUtils::getDateString (event_));
  GladeUtil::setText (placeTf, event_.getPlace());
  GladeUtil::setText (causeTf, event_.getCause());
  GladeUtil::setText (date2Tf, event_.getOriginalDateString());

  GladeUtil::setText (nameLb, name_);
  GladeUtil::setText (eventTypeCmb->get_entry(), 
		      ShowUtils::getEventName (event_.getEventType()));

  const SourceCitation& sourceCit = event_.getSource();
  if (sourceCit.isSourceRecord())
    {
      Source* source = datamodel_.getSource (sourceCit.getRecordId());
      if (source != 0)
	{
	  GladeUtil::setText (sourceTf, source->getTitle());
	}
      else
	{
	  cout << "Source record not found" << endl;
	}
    }
  else
    {
      GladeUtil::setText (sourceTf, sourceCit.getText());
    }

  const NoteCitation& noteCit = event_.getNote();
  if (noteCit.isNoteRecord())
    {
      Note* note = datamodel_.getNote (noteCit.getRecordId());
      if (note != 0)
	{
	  GladeUtil::setText (notesTf, note->getText());
	}
      else
	{
	  cout << "Note record not found" << endl;
	}
    }
  else
    {
      GladeUtil::setText (notesTf, noteCit.getText());
    }
}

// ------------------------------------------------------------------------
// make the window readonly ...
void EventWnd::setReadonly()
{
  dateTf->set_editable (false);
  placeTf->set_editable (false);
  notesTf->set_editable (false);
  causeTf->set_editable (false);
  sourceTf->set_editable (false);

  okBt->set_sensitive (false);
  applyBt->set_sensitive (false);
}

// ------------------------------------------------------------------------
void EventWnd::readDate (const char* line, int* d, int* m, int* y)
{
  char* p1 = 0;
  char* p2 = 0;
  *d = 0;
  *m = 0;
  *y = 0;
  p1 = strchr (line,'-');
  if (p1 != 0)
    {
      p2 = strchr (p1+1,'-');
    }
  else
    {
      p2 = 0;
    }
  if (p1 == 0)
    {
      sscanf (line,"%d",y);
    }
  else if (p2 == 0)
    {
      sscanf (line,"%d",m);
      sscanf (p1+1,"%d",y);
    }
  else
    {
      sscanf (line,"%d",d);
      sscanf (p1+1,"%d",m);
      sscanf (p2+1,"%d",y);
    }
}

// ------------------------------------------------------------------------
// get the updates from the window, and put them in the datamodel.
void EventWnd::doUpdate()
{
  // event_.setIsUpdated (true);
  event_.setPlace (placeTf->get_text());
  event_.setCause (causeTf->get_text());
  //event_.setSource (sourceTf->get_text());
  //event_.setNote (notesTf->get_text());
  int d = 0;
  int m = 0;
  int y = 0;
  const char* str = dateTf->get_text().c_str();
  readDate (str, &d, &m, &y);
  event_.setDate (d,m,y);
}

void EventWnd::on_file1_activate()
{   
}

void EventWnd::on_srcDetailsBt_clicked()
{   
}

void EventWnd::on_okBt_clicked()
{   
  doUpdate();
  // is this bad ?
  delete this; // @TODO do this in a better way !
}

void EventWnd::on_applyBt_clicked()
{   
  doUpdate();
}

void EventWnd::on_closeBt_clicked()
{   
  // is this bad ?
  delete this; // @TODO do this in a better way !
}

gint EventWnd::on_EventWnd_delete_event(GdkEventAny *ev)
{   return 0;
}
