// generated 2002/1/30 19:15:26 CET by gvtienen@gandalf.(none)
// using glademm V0.5_11f
//
// newer (non customized) versions of this file go to PersonWnd.cc_new

// This file is for your program, I won't touch it again!

#include "config.h"
#include "PersonWnd.hh"


#include "glade2UI.h"
#include "gladeUtil.h"
#include <datamodel/genesInfomodel.h>
#include <datamodel/person.h>
#include <datamodel/personInfo.h> // @TODO remove this ?
#include <datamodel/family.h>
#include <datamodel/note.h>
#include <utils/showUtils.h>
#include <stdio.h>
#include <gtk--/style.h> 
#include <libintl.h>
#define _(string) gettext (string)
#define N_(string) (string)

// ------------------------------------------------------------------------
PersonWnd::PersonWnd (Glade2UI& ui, GenesInfomodel& datamodel, Person& person,
		      PersonWnd::OperationMode mode)
  : ui_(ui),
    mode_ (mode),
    datamodel_(datamodel),
    person_(person),
    fatherPid_(GenesDataId::personId),
    motherPid_(GenesDataId::personId),
    spouceFid_(GenesDataId::familyId),
    childPid_(GenesDataId::personId)
{
  if (mode_ == PersonWnd::showOp)
    {
      setEditable(false);
    }
}

// ------------------------------------------------------------------------
PersonWnd::~PersonWnd()
{
}

// ------------------------------------------------------------------------
// fill in all fields of the window
void PersonWnd::initObject()
{
  char buffer [80];
  sprintf (buffer,"ID%02d", person_.getId().getId());
  GladeUtil::setText (idLb, buffer);

  GladeUtil::setText (firstnameTf, person_.getFirstname());
  GladeUtil::setText (surnameTf,person_.getSurname());

  const Event* birth = person_.getBirthEvent();
  if ((birth == 0) && (mode_ == PersonWnd::showOp))
    {
      birthDetailBt->set_sensitive(false);
    }
  GladeUtil::showEvent (birth, birthDateTf, birthPlaceTf);
  const Event* death = person_.getDeathEvent();
  if ((death == 0) && (mode_ == PersonWnd::showOp))
    {
      deathDetailBt->set_sensitive(false);
      deathDateTf->set_sensitive(false);
      deathPlaceTf->set_sensitive(false);
      deathDateLb->set_sensitive(false);
      deathPlaceLb->set_sensitive(false);
      deathFr->set_sensitive(false);
    }
  GladeUtil::showEvent (death, deathDateTf, deathPlaceTf);
  Person::SexType sex = person_.getSex();
  if (sex == Person::female)
    {
      femaleBtn->set_active (true); // @TODO rename widget !
    }
  else if (sex == Person::male)
    {
      maleBtn->set_active (true);
    }
  else
    {
      unknownBtn->set_active (true);
    }

  // check the fonts with "xfontsel", only use std fonts ? (RH7.1)
  Gdk_Font fixed_font("-b&h-lucida-bold-r-*-*-*-120-*-*-*-*-*-*");
  Gtk::Style* style = Gtk::Style::create();
  style->set_font (fixed_font);
  nameTf->set_style (*style);
  GladeUtil::setText (nameTf, ShowUtils::getFullName (person_));

  GenesDataId personId = person_.getId();
  PersonInfo* father = datamodel_.getFatherInfoFrom (personId);
  if (father != 0)
    {
      GladeUtil::setText (fatherTf, ShowUtils::getFullName2 (*father));
      fatherPid_ = father->getPid();
    }
  else
    {
      fatherViewBt->set_sensitive (false);
    }

  PersonInfo* mother = datamodel_.getMotherInfoFrom (personId);
  if (mother != 0)
    {
      GladeUtil::setText (motherTf, ShowUtils::getFullName2 (*mother));
      motherPid_ = mother->getPid();
    }
  else
    {
      motherViewBt->set_sensitive (false);
    }

  const list<GenesDataId>& fidList = person_.getSpouseFamily();

  GenesDataId first_fid;
  int is_first = 1;
  list<GenesDataId>::const_iterator iter = fidList.begin();
  list<string> spouceList;
  while (iter != fidList.end())
    {
      GenesDataId fid = *iter;
      Family* fam = datamodel_.getFamily (fid);
      if (fam != 0)
	{
	  if (is_first == 1)
	    {
	      first_fid = fid;
	      is_first = 0;
	    }
	  GenesDataId pid1 = fam->getFather();
	  GenesDataId pid2 = fam->getMother();
	  GenesDataId pid (GenesDataId::personId);
	  if (pid1 == personId)
	    {
	      pid = pid2;
	    }
	  else
	    {
	      pid = pid1;
	    }
	  PersonInfo* info = datamodel_.getPersonInfo (pid);
	  if (info != 0)
	    {
	      String name3 = ShowUtils::getFullName2 (*info);
	      spouceList.push_back(name3);
	      spousesInfo_.addEntry (name3, pid, fid);
	    }
	  addChildList (fam->getChildren());
	}
      iter++;
    }
  setSpouses (spouceList);
  initEventList();
  initAttributeList();
  initFamilyList();

  const NoteCitation& noteCit = person_.getNote();
  if (noteCit.isNoteRecord())
    {
      Note* note = datamodel_.getNote (noteCit.getRecordId());
      if (note != 0)
	{
	  GladeUtil::setText (notesTf, note->getText()); 
	}
    }
  else
    {
      GladeUtil::setText (notesTf, noteCit.getText()); 
    }
}

// ------------------------------------------------------------------------
// fill in all spouse family related fields of the window
void PersonWnd::setSpouseFamily(const GenesDataId& fid)
{
  // @TODO clean the entries first !
  spouceFid_ = fid;
  Family* fam = datamodel_.getFamily (fid);
  if (fam != 0)
    {
      const Event* marriage = fam->getMarriageEvent();
      GladeUtil::showEvent (marriage, mariageDateTf, mariagePlaceTf);
      const Event* divorce = fam->getDivorceEvent();
      if (divorce != 0)
	{
	  GladeUtil::showEvent (divorce, divorcedDateTf, divorcedPlaceTf);
	}
      else
	{
	  divorceDetailBt->set_sensitive(false);
	  divorcedDateTf->set_sensitive(false);
	  divorcedPlaceTf->set_sensitive(false);
	  divorcedLb->set_sensitive(false);
	  divPlaceLb->set_sensitive(false);
	}
    }
}

// ------------------------------------------------------------------------
void PersonWnd::addChildList(const list<GenesDataId>& children)
{
  char buffer [80];
  int len = children.size();
  list<GenesDataId>::const_iterator iter = children.begin();
      
  while (iter != children.end())
    {
      GenesDataId pid = *iter;
      Person* person = datamodel_.getPerson (pid);
      if (person != 0)
	{
	  const char* line[4];
	  String name = ShowUtils::getFullName (*person);
	  const Event* birth = person->getBirthEvent();
	  String birthStr;
	  String bplace;
	  if (birth != 0)
	    {
	      birthStr = ShowUtils::getDateString (*birth);
	      bplace = birth->getPlace();
	    }

	  line[0] = GladeUtil::getTextList (name);
	  line[1] = GladeUtil::getTextList (birthStr);
	  line[2] = GladeUtil::getTextList (bplace );
	  Person::SexType sex = person->getSex();
	  if (sex == Person::female)
	    {
	      line[3] = _("female");
	    }
	  else if (sex == Person::male)
	    {
	      line[3] = _("male");
	    }
	  else
	    {
	      line[3] = "?";
	    }
	  // @TODO later: use a genesDataId pointer which is garanteed
	  // to exist (not to be deleted)
	  PersonInfo* info = datamodel_.getPersonInfo (pid);
	  int row = addChildRow(line, (gpointer)info);
	}
      iter++;
    }
}

// ------------------------------------------------------------------------
void PersonWnd::addEventList(const list<Event*>& eventList)
{
  const Event* birth = person_.getBirthEvent();
  list<Event*>::const_iterator iter = eventList.begin();
  while (iter != eventList.end())
    {
      Event* event = *iter;
      const char* line[6];
      String eType = ShowUtils::getEventName (event->getEventType());
      String age = ShowUtils::getAgeString (birth, event);
      line[0] = GladeUtil::getTextList (eType);
      line[1] = GladeUtil::getTextList (ShowUtils::getDateString (*event));
      line[2] = age.c_str();
      line[3] = GladeUtil::getTextList (event->getPlace());
      const NoteCitation& noteCit = event->getNote();
      if (noteCit.isNoteRecord())
	{
	  Note* note = datamodel_.getNote (noteCit.getRecordId());
	  if (note != 0)
	    {
	      line[4] = GladeUtil::getTextList (note->getText());
	    }
	  else
	    {
	      cout << "Note record not found" << endl;
	      line[4] = "";
	    }
	}
      else
	{
	  line[4] = GladeUtil::getTextList(noteCit.getText());
	}
      line[5] = "";
      for (int i=0; i < 6; i++)
	{
	  if (line[i] == 0)
	    {
	      line[i] = "";
	    }
	}
      eventLst->rows().push_back(line);
      int row = eventLst->rows().size() - 1;
      eventLst->set_row_data (row, (gpointer) event);
      iter++;
    }
}

// ------------------------------------------------------------------------
void PersonWnd::initEventList()
{
  const list<Event*>& eventList = person_.getEventList ();
  addEventList (eventList);

  const list<GenesDataId>& fidList = person_.getSpouseFamily();
  list<GenesDataId>::const_iterator iter = fidList.begin();
  while (iter != fidList.end())
    {
      GenesDataId fid = *iter;
      Family* fam = datamodel_.getFamily (fid);
      if (fam != 0)
	{
	  const list<Event*>& eventList2 = fam->getEventList ();
	  addEventList (eventList2);
	}
      iter++;
    }
}

// ------------------------------------------------------------------------
void PersonWnd::initAttributeList()
{
  const list<Attribute*>& attributeList = person_.getAttributeList ();
  list<Attribute*>::const_iterator iter = attributeList.begin();
  while (iter != attributeList.end())
    {
      Attribute* attr = *iter;
      const char* line[3];
      String value = attr->getValue();
      String aType = ShowUtils::getAttributeName (attr->getAttributeType());
      line[0] = GladeUtil::getTextList (aType);
      line[1] = GladeUtil::getTextList (value);
      line[2] = "";
      attrLst->rows().push_back(line);
      int row = attrLst->rows().size() - 1;
      attrLst->set_row_data (row, (gpointer) 0);
      iter++;
    }
}

// ------------------------------------------------------------------------
void PersonWnd::addFamilyToList(const GenesDataId& fid, const String& pos)
{
  Family* fam = datamodel_.getFamily (fid);
  if (fam != 0)
    {
      String name = ShowUtils::getFamilyName (datamodel_, *fam);
      const char* line[3]; // position, fam name, dates
      line[0] = pos.c_str();;
      line[1] = name.c_str();
      line[2] = "";
      GladeUtil::addText (familyLst, line);
      int row = familyLst->rows().size() - 1;
      familyLst->set_row_data (row, (gpointer) fam);
    }
}

// ------------------------------------------------------------------------
void PersonWnd::initFamilyList()
{
  const GenesDataId&  id = person_.getChildFamily();
  addFamilyToList (id, _("Child"));
  const list<GenesDataId>&  spouses = person_.getSpouseFamily ();
  list<GenesDataId>::const_iterator iter = spouses.begin();
  while (iter != spouses.end())
    {
      GenesDataId fid = *iter;
      addFamilyToList (fid, _("Spouse"));
      iter++;
    }
}

// ------------------------------------------------------------------------
void PersonWnd::setSpouses(list<string>& spouses)
{
  int len = spouses.size();
  char count [200];
  sprintf (count,"(%d)",len);
  GladeUtil::setText (spouseCountLb, count);
  if (len == 0)
    {
      spouses.push_back("");
    }
  GladeUtil::setTexts (spouseCmb, spouses);
}

// ------------------------------------------------------------------------
int PersonWnd::addChildRow(const char* line[], gpointer info)
{   
  GladeUtil::addText (childLst, line);
  int row = childLst->rows().size() - 1;
  childLst->set_row_data (row, info);
  return (row);
}
 
// ------------------------------------------------------------------------
// make the window editable or readonly
void PersonWnd::setEditable(bool editable)
{
  firstnameTf->set_editable (editable);
  surnameTf->set_editable (editable);
  aliasesTf->set_editable (editable);
  fatherTf->set_editable (editable);
  motherTf->set_editable (editable);
  birthDateTf->set_editable (editable);
  birthPlaceTf->set_editable (editable);
  deathDateTf->set_editable (editable);
  deathPlaceTf->set_editable (editable);
  mariagePlaceTf->set_editable (editable);
  mariageDateTf->set_editable (editable);
  divorcedDateTf->set_editable (editable);
  divorcedPlaceTf->set_editable (editable);
  spouseCmb->get_entry()->set_editable (editable);

  spouseAddBt->set_sensitive (editable);
  spouseDelBt->set_sensitive (editable);
  childAddBt->set_sensitive (editable);
  childDelBt->set_sensitive (editable);
  childUpBt->set_sensitive (editable);
  childDownBt->set_sensitive (editable);
  applyBt->set_sensitive (editable);

//   maleBtn->set_sensitive (editable);
//   femaleBtn->set_sensitive (editable);
//   unknownBtn->set_sensitive (editable);
}

// ------------------------------------------------------------------------
// get the updates from the window, and put them in the datamodel.
void PersonWnd::doUpdate()
{
  if (mode_ != PersonWnd::showOp)
    {
      person_.setFirstname(firstnameTf->get_text());
      person_.setSurname(surnameTf->get_text());
      if (maleBtn->get_active ())
	{
	  person_.setSex(Person::male);
	}
      else if (femaleBtn->get_active ())
	{
	  person_.setSex(Person::female);
	}
      else
	{
	  person_.setSex(Person::undefined);
	}
    }
  if (mode_ == PersonWnd::newOp)
    {
      datamodel_.addPerson (&person_);
      // what when the user cancels this new ?
      mode_ = PersonWnd::editOp;
    }
}

// ------------------------------------------------------------------------
void PersonWnd::on_save_as1_activate()
{   
}

void PersonWnd::on_print1_activate()
{   
}

void PersonWnd::on_close1_activate()
{   
  // is this bad ?
  delete this; // @TODO do this in a better way !
}

void PersonWnd::on_update_person1_activate()
{   
  mode_ = PersonWnd::editOp;
  setEditable (true);
}

void PersonWnd::on_mark_person1_activate()
{   
}

void PersonWnd::on_mark_subtree1_activate()
{   
}

void PersonWnd::on_unmark_subtree1_activate()
{   
}

void PersonWnd::on_unmark_person1_activate()
{   
}

void PersonWnd::on_help1_activate()
{   
}

void PersonWnd::on_birthDetailBt_clicked()
{   
  // @TODO do this better (always use pointers ?)
  String name = ShowUtils::getFullName (person_);
  Event* birth = person_.getBirthEvent();
  if ((mode_ == PersonWnd::showOp) && (birth != 0))
    {
      ui_.showEvent (birth, name);
    }
//   else if (birth == 0)
//     {
//       Event* birth2 = new Event (Event::birth);
//       person_.addEvent (*birth2);
//     }
//   if (mode_ != PersonWnd::showOp)
//     {
//       ui_.editEvent (person_.getBirthEvent(), name);
//     }
}

void PersonWnd::on_fatherViewBt_clicked()
{   
  ui_.showPerson (fatherPid_);
}

void PersonWnd::on_motherViewBt_clicked()
{   
  ui_.showPerson (motherPid_);
}

void PersonWnd::on_deathDetailBt_clicked()
{   
  String name = ShowUtils::getFullName (person_);
  ui_.showEvent (person_.getDeathEvent(),name);
}

void PersonWnd::on_spouseAddBt_clicked()
{   
  ui_.addPerson();
  // @TODO we need to get a reference from this new person and add it as a
  // spouce
}

void PersonWnd::on_spouseDelBt_clicked()
{   
}

void PersonWnd::on_spouseViewBt_clicked()
{   
  ::Gtk::Entry* entry = spouseCmb->get_entry();
  if (entry != 0)
    {
      string txt = entry->get_text();
      const GenesDataId* id = spousesInfo_.getIdFor (txt);
      if (id != 0)
 	{
 	  ui_.showPerson (*id);
 	}
    }
}

void PersonWnd::on_mariageDetailBt_clicked()
{   
  Family* fam = datamodel_.getFamily (spouceFid_);
  if (fam != 0)
    {
      String name = ShowUtils::getFamilyName (datamodel_, *fam);
      ui_.showEvent (fam->getMarriageEvent(), name); // @TODO spouse name too?
    }
}

void PersonWnd::on_divorceDetailBt_clicked()
{   
  Family* fam = datamodel_.getFamily (spouceFid_);
  if (fam != 0)
    {
      String name = ShowUtils::getFamilyName (datamodel_, *fam);
      ui_.showEvent (fam->getDivorceEvent(), name); // @TODO spouse name too?
    }
}

void PersonWnd::on_viewFamBt_clicked()
{   
  Family* fam = datamodel_.getFamily (spouceFid_);
  if (fam != 0)
    {
       ui_.showFamily (*fam);
    }
}

void PersonWnd::on_spouseTf_changed()
{   
  ::Gtk::Entry* entry = spouseCmb->get_entry();
  if (entry != 0)
    {
      string txt = entry->get_text();
      const GenesDataId* fid = spousesInfo_.getFidFor (txt);
      if (fid != 0)
 	{
 	  setSpouseFamily(*fid); 
 	}
    }
}

void PersonWnd::on_childViewBt_clicked()
{   
  ui_.showPerson (childPid_);
}

void PersonWnd::on_childAddBt_clicked()
{   
}

void PersonWnd::on_childDelBt_clicked()
{   
}

void PersonWnd::on_childUpBt_clicked()
{   
}

void PersonWnd::on_childDownBt_clicked()
{   
}

void PersonWnd::on_childLst_select_row(gint row, gint column, GdkEvent *event)
{   
  gpointer data = childLst->get_row_data (row);
  PersonInfo* info = (PersonInfo*) data;
  if (info != 0)
    {
      childPid_ = info->getPid();
    }
}

void PersonWnd::on_childLst_unselect_row(gint row, gint column, GdkEvent *event)
{   
  childPid_ = GenesDataId(GenesDataId::personId);
}

void PersonWnd::on_famDetailsBt_clicked()
{   
  Gtk::CList_Helpers::SelectionList selects = familyLst->selection();
  if (selects.size() > 0)
    {
      gint row = selects.front().get_row_num();
      gpointer data = familyLst->get_row_data (row);
      Family* fam = (Family*) data;     // @TODO change this, use dataId ?
      if (fam != 0)
	{
	  ui_.showFamily (*fam);
	}
    }
}

void PersonWnd::on_famAddBt_clicked()
{   
}

void PersonWnd::on_famDelBt_clicked()
{   
}

void PersonWnd::on_eventAddBt_clicked()
{   
}

void PersonWnd::on_eventDelBt_clicked()
{   
}

void PersonWnd::on_eventDetailsBt_clicked()
{   
  Gtk::CList_Helpers::SelectionList selects = eventLst->selection();
  if (selects.size() > 0)
    {
      gint row = selects.front().get_row_num();
      gpointer data = eventLst->get_row_data (row);
      Event* ev = (Event*) data;     // @TODO change this, use dataId ?
      if (ev != 0)
	{
	  ui_.showEvent (ev,ShowUtils::getFullName (person_));
	}
    }
}

void PersonWnd::on_attrDetailsBt_clicked()
{   
}

void PersonWnd::on_attrAddBt_clicked()
{   
}

void PersonWnd::on_attrDelBt_clicked()
{   
}

void PersonWnd::on_okBt_clicked()
{   
  doUpdate();
  // is following this bad ?
  delete this; // @TODO do this in a better way !
}

void PersonWnd::on_applyBt_clicked()
{   
  doUpdate();
}

void PersonWnd::on_closeBt_clicked()
{   
  // is this bad ?
  delete this; // @TODO do this in a better way !
}

gint PersonWnd::on_personWnd_delete_event(GdkEventAny *ev)
{   return 0;
}
