/***************************************************************************
                         genesComboInfo.cpp
                        -------------------
    begin                : 04 Mar 2001
    copyright            : (C) 2000 by The Genes Development Team
    email                : Geert.Vantienen@advalvas.be
    module               : Genes glade2
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#include <glade2/genesComboInfo.h>

// ------------------------------------------------------------------------
GenesComboInfo::GenesComboInfo ()
{
}

// ------------------------------------------------------------------------
GenesComboInfo::~GenesComboInfo ()
{
  clearList ();
}

// ------------------------------------------------------------------------
GenesComboInfo::ComboEntryInfo::ComboEntryInfo (const String& name, 
						const GenesDataId& id)
  : text_ (name),
    id_ (id),
    fid_ (GenesDataId::familyId)
{
}

// ------------------------------------------------------------------------
GenesComboInfo::ComboEntryInfo::ComboEntryInfo (const String& name, 
						const GenesDataId& pid,
						const GenesDataId& fid)
  : text_ (name),
    id_ (pid),
    fid_ (fid)
{
}

// ------------------------------------------------------------------------
void GenesComboInfo::addEntry (const String& name, const GenesDataId& id)
{
  ComboEntryInfo* entry = new ComboEntryInfo (name, id);
  infoList_.push_back(entry);
}

// ------------------------------------------------------------------------
void GenesComboInfo::addEntry (const String& name, const GenesDataId& pid,
			       const GenesDataId& fid)
{
  ComboEntryInfo* entry = new ComboEntryInfo (name, pid, fid);
  infoList_.push_back(entry);
}

// ------------------------------------------------------------------------
void GenesComboInfo::clearList ()
{
  cout << "clearList (genesComboInfo)" << endl;
  list<ComboEntryInfo*>::iterator iter = infoList_.begin();
  while (iter != infoList_.end())
    {
      ComboEntryInfo* entryInfo = *iter;
      delete entryInfo;
      iter++;
    }
  while (! infoList_.empty())
    {
      infoList_.pop_front();
    }
}

// ------------------------------------------------------------------------
const GenesDataId* GenesComboInfo::getIdFor (const String& name) const
{
  GenesDataId* id = 0;
  int loop = 1;
  list<ComboEntryInfo*>::const_iterator iter = infoList_.begin();
  while ((loop == 1) && (iter != infoList_.end()))
    {
      ComboEntryInfo* entryInfo = *iter;
      if (entryInfo != 0)
	{
	  if (entryInfo->text_ == name)
	    {
	      id = &(entryInfo->id_);
	      loop = 0;
	    }
	}
      iter++;
    }
  return (id);
}
  
// ------------------------------------------------------------------------
const GenesDataId* GenesComboInfo::getFidFor (const String& name) const
{
  GenesDataId* fid = 0;
  int loop = 1;
  list<ComboEntryInfo*>::const_iterator iter = infoList_.begin();
  while ((loop == 1) && (iter != infoList_.end()))
    {
      ComboEntryInfo* entryInfo = *iter;
      if (entryInfo != 0)
	{
	  if (entryInfo->text_ == name)
	    {
	      fid = &(entryInfo->fid_);
	      loop = 0;
	    }
	}
      iter++;
    }
  return (fid);
}
  
// ------------------------------------------------------------------------


