#ifndef GENESCOMBOINFO_H
#define GENESCOMBOINFO_H

/***************************************************************************
                          genesComboInfo.h
                        -------------------
    begin                : 04 Mar 2001
    copyright            : (C) 2000 by The Genes Development Team
    email                : Geert.Vantienen@advalvas.be
    module               : Genes glade2
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#include <datamodel/genesDataId.h>
#include <datamodel/String.h>
#include <list>

// GenesComboInfo will keep names and dataId of entries in a combo box
class GenesComboInfo
{
 public:
  GenesComboInfo ();
  ~GenesComboInfo ();

  void               addEntry (const String&,const GenesDataId&);
  void               addEntry (const String&,const GenesDataId& pid,
			                     const GenesDataId& fid);
  void               clearList ();
  const GenesDataId* getIdFor (const String&) const;
  const GenesDataId* getFidFor (const String&) const;
  
 private:
  class ComboEntryInfo
  {
  public:
    String      text_;
    GenesDataId id_;
    GenesDataId fid_;
    ComboEntryInfo (const String&, const GenesDataId&);
    ComboEntryInfo (const String&, const GenesDataId&, const GenesDataId&);
  };

  list<ComboEntryInfo*> infoList_;
};

#endif
