/***************************************************************************
                            gladeUtil.h
                        -------------------
    begin                : 22 Jan 2002
    copyright            : (C) 2002 by The Genes Development Team
    email                : Geert.Vantienen@advalvas.be
    module               : Genes glade2
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#include "gladeUtil.h"
#include <gtk--/entry.h>
#include <gtk--/label.h>
#include <gtk--/text.h>
#include <gtk--/clist.h>
#include <gtk--/combo.h>
#include <utils/utf8-locale.h>
#include <utils/showUtils.h>

// ------------------------------------------------------------------------
char* getConvertedString (const String& str)
{
  return (convert_utf8_to_locale(str.c_str(),0));
}

// ------------------------------------------------------------------------
char* getConvertedString (const char* str)
{
  return (convert_utf8_to_locale(str,0));
}

// ------------------------------------------------------------------------
void GladeUtil::setText (Gtk::Entry* textField, const String& str)
{
  textField->set_text (getConvertedString(str));
}

// ------------------------------------------------------------------------
void GladeUtil::setText (Gtk::Label* label, const String& str)
{
  label->set_text (getConvertedString(str));
}

// ------------------------------------------------------------------------
void GladeUtil::setText (Gtk::Text* textField, const String& str)
{
  textField->insert (getConvertedString(str));
}

// ------------------------------------------------------------------------
void GladeUtil::setTexts (Gtk::Combo* comboBox, list<String>& strList)
{
  list<String> cs;
  list<String>::iterator strIter;
  for (strIter = strList.begin(); strIter != strList.end(); ++strIter) {
    cs.push_back(getConvertedString(*strIter));
  }
  comboBox->set_popdown_strings(cs);  
}

// ------------------------------------------------------------------------
void GladeUtil::addText (Gtk::CList* clist, const char** str)
{
  list<string> cs;
  while (*str) {
    cs.push_back(getConvertedString(*str));
    str++;
  }
  clist->rows().push_back(cs);  
}

// ------------------------------------------------------------------------
const char* GladeUtil::getTextList (const String& str)
{
  const char* value = str.c_str(); //getConvertedString(str);
  return (value);
}

// ------------------------------------------------------------------------
void GladeUtil::showEvent (const Event* event, Gtk::Entry* dateTf, 
			   Gtk::Entry* placeTf)
{
  if (event != 0)
    {
      GladeUtil::setText (dateTf, ShowUtils::getDateString(*event));
      GladeUtil::setText (placeTf, event->getPlace());
    }
}

// ------------------------------------------------------------------------
