/***************************************************************************
                            main.cpp
                        -------------------
    begin                : Mon 20 Dec 2000
    copyright            : (C) 2000 by The Genes Development Team
    email                : Geert.Vantienen@advalvas.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#include "genesCore/genesApplication.h"
#include "glade2/glade2UI.h"
#include "test/simpleUI.h"
#include "test/testImport.h"
#include "test/importGed0.h"
#include "gedcom/importGedcom.h"
#include "datamodel/genesInfomodel.h"
#include "config.h"
#include <iostream.h>

#include <libintl.h>
#define _(string) gettext (string)
#define N_(string) (string)


// ------------------------------------------------------------------------
void usage ()
{
  cout << "Usage: genes [<mode>] [<gedcom file>]" << endl;
  cout << "  mode=0 for terminal mode" <<endl;
}

// ------------------------------------------------------------------------
int main (int argc, char* argv[])
{

  GenesApplication applic;
  applic.start();

  GenesInfomodel   datamodel;
  TestImport       import1 (applic);
  ImportGed0       import2 (applic);
  ImportGedcom     import3 (applic);

  GenesUICore*     ui = 0;
  int              argPos = 1; 

  if (argc > 1)
    {
      if (argv[1][0] == '0')
	{
	  ui = new SimpleUI (applic);
	  argPos++;
	}
    }
  if (ui == 0)
    {
      Glade2UI* glade = new Glade2UI (applic);
      glade->gtkinit (argc,argv);
      ui = glade;
    }

  applic.setDatamodel (&datamodel);
  applic.setUserInterface (ui);
  applic.registerImportModule (&import1);
  applic.registerImportModule (&import2);
  applic.registerImportModule (&import3);

  ui->initObject();
  import1.initObject();
  import2.initObject();
  import3.initObject();

  if (argPos < argc)
    {
      datamodel.block_updates();
      import3.load(argv[argPos],datamodel); 
      datamodel.deblock_updates();
      //ui->showIndex();
    }

  applic.loop();
  applic.stop();
  return (0);
}
