/***************************************************************************
                          ImportGed0.cpp
                        -------------------
    begin                : 30 Jul 2001
    copyright            : (C) 2000 by The Genes Development Team
    email                : Geert.Vantienen@advalvas.be
    module               : Genes Test
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

/* This is a very *very* bad gedcom parser, and should be replaced with a 
   decent parser */

#include "importGed0.h"
#include <genesCore/genesApplication.h>
#include <datamodel/genesInfomodel.h>
#include <datamodel/event.h>
#include <datamodel/family.h>
#include <datamodel/person.h>
#include <datamodel/note.h>
#include <datamodel/attribute.h>
#include <datamodel/source.h>
#include <modules.h>
#include <iostream.h>

// ------------------------------------------------------------------------
ImportGed0::ImportGed0 (GenesApplication& applic)
  : GenesImportCore (applic, IMPORT_GED0_MOD)
{
}

// ------------------------------------------------------------------------
ImportGed0::~ImportGed0 ()
{
}

// ------------------------------------------------------------------------
// @TODO later return GenesStatus
void ImportGed0::load (const String& filename, GenesInfomodel& datamodel)
{
  cout << "Status: loading file ..." << endl;         // @TODO use showStatus

  FILE* stream = 0;
  stream = fopen (filename.c_str(),"r");
  if (stream != 0)
    {
      parse_round1 (stream, datamodel);
      fseek (stream, 0L, SEEK_SET);
      parse_round2 (stream, datamodel);
      fclose (stream);
    }
  else
    {
      cout << "STATUS: could not read file: " << filename<<endl;
    }

  // @TODO notify ui that loading is done ...
  datamodel.buildInfoList();
}


// ------------------------------------------------------------------------
void ImportGed0::parse_round1 (FILE* stream, GenesInfomodel& datamodel)
{
  char line [251];
  int i = 0;
  Person* pers = 0;
  Family* fam  = 0;
  Note*   note = 0;
  Source* src  = 0;
  //Event* event=0;

  fgets (line,200,stream);   //@TODO change this
  while (!feof (stream))
    {
      if (line[0] == '0')
	{
	  if (line[2] == '@')
	    {
	      char* ptr = strchr (&(line[3]),'@');
	      if (ptr != 0) // this should always be the case ...
		{
		  *(ptr + 1) = 0;    // end this string ...
		}
	      switch (line[3])
		{
		case 'I' :
		  {
		    const GenesDataId& id = GenesDataId::getNextPersonId();
		    pers = new Person (id);
		    pers->setOriginalId(&(line[2]));
		    datamodel.addPerson (pers);
		    gedKeys_[&(line[2])] = id;
		    break;
		  }
		case 'F' :
		  {
		    const GenesDataId& id = GenesDataId::getNextFamilyId();
		    fam = new Family (id);
		    fam->setOriginalId(&(line[2]));
		    datamodel.addFamily (fam);
		    gedKeys_[&(line[2])] = id;
		    break;
		  }
		case 'S' :
		  {
		    const GenesDataId& id = GenesDataId::getNextSourceId();
		    src = new Source (id);
		    src->setOriginalId(&(line[2]));
		    datamodel.addSource (src);
		    gedKeys_[&(line[2])] = id;
		    break;
		  }
		case 'N' :
		  {
		    const GenesDataId& id = GenesDataId::getNextNoteId();
		    note = new Note (id);
		    note->setOriginalId(&(line[2]));
		    datamodel.addNote (note);
		    gedKeys_[&(line[2])] = id;
		    break;
		  }
		default :
		  cout << "-" << &(line[2]) << endl;
		}
	    }
	}
      fgets (line,200,stream);
    }
}

// ------------------------------------------------------------------------
void ImportGed0::parse_round2 (FILE* stream, GenesInfomodel& datamodel)
{
  char line [251];
  int i = 0;
  Person* pers = 0;
  Family* fam  = 0;
  Note*   note = 0;
  Source* src  = 0;
  Event*  event = 0;

  fgets (line,200,stream);
  while (!feof (stream))
    {
      if ((line[0] == '0') || (line[0] == '1'))
	{
	  // do we still have an event object which is not yet used ?
	  if (event != 0) 
	    {
	      if (pers != 0)
		{
		  pers->addEvent (event);
		  event = 0;
		}
	      else if (fam != 0)
		{
		  fam->addEvent (event);
		  event = 0;
		}
	    }
	}
      if (line[0] == '0')
	{
	  if (line[2] == '@')
	    {
	      switch (line[3])
		{
		case 'I' :
		  {
		    GenesDataId& id = translateIdFrom (&(line[2]));
		    pers = datamodel.getPerson (id);
		    if (pers == 0)
		      {
			cout << "Oops, person not found" << endl;
		      }
		    fam = 0;
		    src = 0;
		    note = 0;
		    break;
		  }
		case 'F' :
		  {
		    GenesDataId& id = translateIdFrom (&(line[2]));
		    fam = datamodel.getFamily (id);
		    if (fam == 0)
		      {
			cout << "Oops, family not found" << endl;
		      }
		    pers = 0;
		    src = 0;
		    note = 0;
		    break;
		  }
		case 'S' :
		  {
		    GenesDataId& id = translateIdFrom (&(line[2]));
		    src = datamodel.getSource (id);
		    if (src == 0)
		      {
			cout << "Oops, source not found" << endl;
		      }
		    pers = 0;
		    fam = 0;
		    note = 0;
		    break;
		  }
		case 'N' :
		  {
		    GenesDataId& id = translateIdFrom (&(line[2]));
		    note = datamodel.getNote (id);
		    if (note == 0)
		      {
			cout << "Oops, note not found" << endl;
		      }
		    pers = 0;
		    fam = 0;
		    src = 0;
		    break;
		  }
		default :
		  addLostData (line);
		}
	    }
	  else
	    {
	      addLostData (line);
	    }
	}
      else if (line[0] == '1')
	{
	  if (pers != 0)
	    {
	      parseNiv1Pers (line, *pers, event);
	    }
	  else if (fam != 0)
	    {
	      parseNiv1Fam (line, *fam, event, datamodel);
	    }
	  else if (src != 0)
	    {
	      parseNiv1Source (line, *src, datamodel);
	    }
	  else if (note != 0)
	    {
	      parseNiv1Note (line, *note, datamodel);
	    }
	  else
	    {
	      addLostData (line);
	    }
	}
      else if (line[0] == '2')
	{
	  if (event != 0)
	    {
	      parseNiv2 (line, *event);
	    }
	  else
	    {
	      addLostData (line);
	    }
	}
      else
	{
	  addLostData (line);
	}
      fgets (line,200,stream);
    }
}

// ------------------------------------------------------------------------
// keep the not parsed data, so that it can be saved again (if saved to
// gedcom format
void ImportGed0::addLostData (char* line, Person&)
{
  cout << "Unknown person data: " << line;
}

// ------------------------------------------------------------------------
// keep the not parsed data, so that it can be saved again (if saved to
// gedcom format
void ImportGed0::addLostData (char* line, Family&)
{
  cout << "Unknown family data: " << line;
}

// ------------------------------------------------------------------------
// keep the not parsed data, so that it can be saved again (if saved to
// gedcom format
void ImportGed0::addLostData (char* line, Event&)
{
  cout << "Unknown event data: " << line;
}

// ------------------------------------------------------------------------
// keep the not parsed data that does not belong to person or family.
void ImportGed0::addLostData (char* line)
{
  cout << "Unknown data: " << line;
}

// ------------------------------------------------------------------------
void ImportGed0::addSource (ExtraRecordData& rec, char* line)
{
  if (line[0] == '@')
    {
      GenesDataId& id = translateIdFrom (line);
      SourceCitation citation (id);
      rec.addSource (citation);
    }
  else
    {
      SourceCitation citation (line);
      rec.addSource (citation);
    }
}

// ------------------------------------------------------------------------
void ImportGed0::addNote (ExtraRecordData& rec, char* line)
{
  if (line[0] == '@')
    {
      GenesDataId& id = translateIdFrom (line);
      NoteCitation citation (id);
      rec.addNote (citation);
    }
  else
    {
      NoteCitation citation (line);
      rec.addNote (citation);
    }
}

// ------------------------------------------------------------------------
void ImportGed0::parseNiv1Pers (char* line, Person& pers, Event*& event)
{
  char tmp1 [280];
  char tmp2 [280];
  event = 0;
  if (strncmp (&(line[2]),"NAME",4)==0)
    {
      parseName (&(line[7]),tmp1,tmp2);
      pers.setFirstname (tmp1);
      pers.setSurname (tmp2);
    }
  else if (strncmp (&(line[2]),"BIRT",4)==0)
    {
      event = new Event (GenesDataId::getNextEventId(), Event::birth);
      // don't add the event yet ! (event object will be copied ...)
    }
  else if (strncmp (&(line[2]),"DEAT",4)==0)
    {
      event = new Event (GenesDataId::getNextEventId(), Event::death);
      // don't add the event yet ! (event object will be copied ...)
    }
  else if (strncmp (&(line[2]),"SEX",3)==0)
    {
      if (line[6] == 'F')
	{
	  pers.setSex (Person::female);
	}
      else if (line[6] == 'M')
	{
	  pers.setSex (Person::male);
	}
      else
	{
	  cout << "Parse error reading sexType" << endl;
	}
    }
  else if (strncmp (&(line[2]),"FAMC",4)==0)
    {
      GenesDataId& id = translateIdFrom (&(line[7]));
      pers.setChildFamily (id); // should be addChildFamily ?
    }
  else if (strncmp (&(line[2]),"FAMS",4)==0)
    {
      GenesDataId& id = translateIdFrom (&(line[7]));
      pers.addSpouseFamily (id);
    }
  else if (strncmp (&(line[2]),"SOURC",4)==0)
    {
      addSource (pers, &(line[7]));
    }
  else if (strncmp (&(line[2]),"NOTE",4)==0)
    {
      addNote (pers, &(line[7]));
    }
  else if (strncmp (&(line[2]),"TITL",4)==0)
    {
      Attribute* attr 
	= new Attribute (GenesDataId::getNextEventId(), Attribute::title, 
			 &(line[7]));
      pers.addAttribute (attr);
    }
  else if (strncmp (&(line[2]),"OCCU",4)==0)
    {
      Attribute* attr 
	= new Attribute (GenesDataId::getNextEventId(), Attribute::occupation, 
			 &(line[7]));
      pers.addAttribute (attr);
    }
  else
    {
      addLostData (line, pers);
    }
}

// ------------------------------------------------------------------------
void ImportGed0::parseNiv1Fam (char* line, Family& fam, Event*& event,
			       GenesInfomodel& datamodel)
{
  if (strncmp (&(line[2]),"HUSB",4) == 0)
    {
      GenesDataId& id = translateIdFrom (&(line[7]));
      fam.setFather (id);
    }
  else if (strncmp (&(line[2]),"WIFE",4)==0)
    {
      GenesDataId& id = translateIdFrom (&(line[7]));
      fam.setMother (id);
    }
  else if (strncmp (&(line[2]),"CHIL",4)==0)
    {
      GenesDataId& id = translateIdFrom (&(line[7]));
      fam.addChild (id);
    }
  else if (strncmp (&(line[2]),"MARR",4)==0)
    {
      event = new Event (GenesDataId::getNextEventId(), Event::marriage);
      // don't add the event yet ! (event object will be copied during add)
    }
  else if (strncmp (&(line[2]),"DIV",3)==0)
    {
      event = new Event (GenesDataId::getNextEventId(), Event::divorce);
      // don't add the event yet ! (event object will be copied during add)
    }
  else if (strncmp (&(line[2]),"SOURC",4)==0)
    {
      addSource (fam, &(line[7]));
    }
  else if (strncmp (&(line[2]),"NOTE",4)==0)
    {
      addNote (fam, &(line[7]));
    }
  else
    {
      addLostData (line, fam);
    }
}

// ------------------------------------------------------------------------
void ImportGed0::parseNiv1Source (char* line, Source& src,
			       GenesInfomodel& datamodel)
{
  if (strncmp (&(line[2]),"TITL",4) == 0)
    {
      src.setTitle (&(line[7]));
    }
  else if (strncmp (&(line[2]),"AUTH",4) == 0)
    {
      src.setAuthor (&(line[7]));
    }
  else
    {
      addLostData (line); // @TODO make it specific for this source
    }
}

// ------------------------------------------------------------------------
void ImportGed0::parseNiv1Note (char* line, Note& note,
				GenesInfomodel& datamodel)
{
  if (strncmp (&(line[2]),"CONC",4) == 0)
    {
      note.concatText (&(line[7]));
    }
  else if (strncmp (&(line[2]),"CONT",4) == 0)
    {
      note.addText (&(line[7]));
    }
  else
    {
      addLostData (line); // @TODO make it specific for this note
    }
}

// ------------------------------------------------------------------------
GenesDataId& ImportGed0::translateIdFrom (char* line)
{
  char* ptr = strchr (&(line[1]),'@');
  if (ptr != 0) // this should always be the case ...
    {
      *(ptr + 1) = 0;    // end this string ...
    }
  GenesDataId& id = gedKeys_[line];
  return (id);
}

// ------------------------------------------------------------------------
void ImportGed0::parseNiv2 (char* line, Event& event)
{
  int d,m,y = 0;

  if (strncmp (&(line[2]),"DATE",4)==0)
    {
      parseDat (&(line[7]),&d,&m,&y);
      event.setDate (d,m,y);
      event.setOriginalDateString (&(line[7]));
    }
  else if (strncmp (&(line[2]),"PLAC",4)==0)
    {
      event.setPlace (&(line[7]));
    }
  else if (strncmp (&(line[2]),"CAUS",4)==0)
    {
      event.setCause (&(line[7]));
    }
  else if (strncmp (&(line[2]),"SOUR",4)==0)
    {
      addSource (event, &(line[7]));
    }
  else if (strncmp (&(line[2]),"NOTE",4)==0)
    {
      addNote (event, &(line[7]));
    }
  else
    {
      addLostData (line, event);
    }
}

// ------------------------------------------------------------------------
void ImportGed0::parseName (char* line, char* fname, char* sname)
{
  char * ptr,*ptr2 = 0;
  int pos = 0;
  ptr = strchr (line,'/');
  if (ptr == 0)
    {
      pos = strlen (line) - 1;
      strncpy (fname,line,pos);
      fname[pos]='\0';
      strcpy (sname, "");
      return;
    }
  pos = (int) (ptr-line);
  strncpy (fname,line,pos);
  if (fname[pos-1]==' ')
    {
      pos--;
    }
  fname[pos]='\0';

  ptr2 = strchr (ptr+1,'/');
  if (ptr2 != 0)
    {
      strncpy (sname,ptr+1,ptr2-ptr-1);
      sname[ptr2-ptr-1] = '\0';
    }
  else                                   // overbodig ???
    {
      strcpy (sname,ptr+1);
      if (sname[strlen(sname)-1] == '/')
	{
	  sname[strlen(sname)-1] = '\0';
	}
    }
}

// ------------------------------------------------------------------------
int ImportGed0::parseMonth (char* line)
{
  int result;
  if (strncmp(line,"Jan",3)==0)
    result = 1;
  else if (strncmp(line,"Feb",3)==0)
    result = 2;
  else if (strncmp(line,"Mar",3)==0)
    result = 3;
  else if (strncmp(line,"Apr",3)==0)
    result = 4;
  else if (strncmp(line,"May",3)==0)
    result = 5;
  else if (strncmp(line,"Jun",3)==0)
    result = 6;
  else if (strncmp(line,"Jul",3)==0)
    result = 7;
  else if (strncmp(line,"Aug",3)==0)
    result = 8;
  else if (strncmp(line,"Sep",3)==0)
    result = 9;
  else if (strncmp(line,"Oct",3)==0)
    result = 10;
  else if (strncmp(line,"Nov",3)==0)
    result = 11;
  else if (strncmp(line,"Dec",3)==0)
    result = 12;
  else  
    {
      result = 0; // ERROR !!!
      cout << "could not parse month : " << line << endl;
    }
  return result;
}
// ------------------------------------------------------------------------
void ImportGed0::parseDat (char* line, int* d, int* m, int* y)
{
  char* p1 = 0;
  char* p2 = 0;
  *d = 0;
  *m = 0;
  *y = 0;
  p1 = strchr (line,' ');
  if (p1 != 0)
    {
      p2 = strchr (p1+1,' ');
    }
  else
    {
      p2 = 0;
    }
  if (p1 == 0)
    {
      sscanf (line,"%d",y);
    }
  else if (p2 == 0)
    {
      *m = parseMonth(line);
      sscanf (p1+1,"%d",y);
    }
  else
    {
      sscanf (line,"%d",d);
      *m = parseMonth(p1+1);
      sscanf (p2+1,"%d",y);
    }
}

// ------------------------------------------------------------------------
