#ifndef IMPORTGED0_H
#define IMPORTGED0_H

/***************************************************************************
                           importGed0.h
                        -------------------
    begin                : 30 Jul 2001
    copyright            : (C) 2000 by The Genes Development Team
    email                : Geert.Vantienen@advalvas.be
    module               : Genes Test
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

/* This is a very *very* bad gedcom parser, and should be replaced with a 
   decent parser */

#include <genesCore/genesImportCore.h>
#include <datamodel/genesDataId.h>
#include <stdio.h>
#include <stl.h>

class ExtraRecordData;
class Person;
class Event;
class Family;
class Source;
class Note;

class ImportGed0 : public GenesImportCore
{
 public:
  ImportGed0 (GenesApplication&);
  virtual ~ImportGed0 ();

  virtual void load(const String&, GenesInfomodel& datamodel); // @TODO return GenesStatus
  void parse_round1 (FILE* stream, GenesInfomodel& datamodel);
  void parse_round2 (FILE* stream, GenesInfomodel& datamodel);

 private:
  void parseName (char* line, char* fname, char* sname);
  int  parseMonth (char* line);
  void parseDat (char* line, int* d, int* m, int* y);
  void parseNiv1Pers (char* line, Person&, Event*&);
  void parseNiv1Fam (char* line, Family&, Event*&, GenesInfomodel&);
  void parseNiv1Source (char* line, Source&, GenesInfomodel&);
  void parseNiv1Note (char* line, Note&, GenesInfomodel&);
  void parseNiv2 (char* line, Event& event);
  GenesDataId& translateIdFrom (char* line);

  void addSource (ExtraRecordData& rec, char* line);
  void addNote (ExtraRecordData& rec, char* line);

  void addLostData (char* line, Person&);
  void addLostData (char* line, Family&);
  void addLostData (char* line, Event&);
  void addLostData (char* line);

  map<String, GenesDataId> gedKeys_;
};

#endif
